-- REPLACE DBNAME with the name of the database you are runnINg this script agaINst, USERNAME with username YOU are usINg to connect to the database, AND USERPASSWD with your password
CONNECT TO DBNAME USER USERNAME USING USERPASSWD;  

-- REPLACE DBSCHEMA with the schema of your database
SET CURRENT SCHEMA DBSCHEMA;


DROP INDEX TPOOL_ENID_XU;
DROP INDEX TPOOL_RK_CU;                      
DROP INDEX POOL_DOM_ID_XXX; 
DROP INDEX POOL_USRGROUP_XXX ; 
DROP INDEX POOL_MGR_XXX; 
DROP INDEX TPOO_NID_XX; 
DROP INDEX TPOOL_EXTREF_XX;   


CREATE TABLE TMT_POOLS_TMP  (
		  LEVEL_ID INTEGER NOT NULL ,
		  TYPE_ID INTEGER NOT NULL WITH DEFAULT 0,
		  MAX_RANK INTEGER NOT NULL WITH DEFAULT 0,
		  CHILD_COUNT INTEGER NOT NULL WITH DEFAULT 0,
		  DELETED_COUNT INTEGER NOT NULL WITH DEFAULT 0,
		  ELEMENT_ID CHAR(32) ,
		  ELEMENT_NAME VARCHAR(100) ,
		  PARENT_ID CHAR(32) ,
		  REC_USER CHAR(32) ,
		  REC_STATUS CHAR(1) NOT NULL WITH DEFAULT 'O',
		  REC_DATETIME TIMESTAMP NOT NULL WITH DEFAULT CURRENT TIMESTAMP,
		  LABEL VARCHAR(50) ,
		  DESCRIPTION VARCHAR(4096) ,
		  DEFAULT_FLAG CHAR(1) ,
		  RANK VARCHAR(128) NOT NULL ,
		  DOMAIN_ID CHAR(32) ,
		  MANAGER_ID CHAR(32) ,
		  COMPANY_NAME VARCHAR(50) ,
		  ADDRESS VARCHAR(255) ,
		  PHONE VARCHAR(25) ,
		  FAX VARCHAR(25) ,
		  WEBSITE VARCHAR(255) ,
		  CONTACT_NAME VARCHAR(50) ,
		  OTHER_LOCATION VARCHAR(255) ,
		  YEAR_IN_BUSINESS INTEGER ,
		  CLIENT_MORE_100_EMPLOYEES INTEGER ,
		  CLIENT_MORE_1000_EMPLOYEES INTEGER ,
		  CLIENT_MORE_10000_EMPLOYEES INTEGER ,
		  NUMBER_EMPLOYEES INTEGER ,
		  NUMBER_POOLS INTEGER ,
		  NUMBER_CLIENTS INTEGER ,
		  ANNUAL_REVENUES DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		  BILLING_ADDRESS VARCHAR(255) ,
		  BILLING_PHONE VARCHAR(25) ,
		  BILLING_FAX VARCHAR(25) ,
		  BILLING_EMAIL VARCHAR(50) ,
		  EQUAL_OPPORTUNITY CHAR(1) ,
		  MAJOR_REVISION SMALLINT NOT NULL WITH DEFAULT 0,
		  MINOR_REVISION SMALLINT NOT NULL WITH DEFAULT 1,
		  REVISION_IMPACT INTEGER WITH DEFAULT 137,
		  REVISION_TYPE INTEGER WITH DEFAULT 920,
		  REVISION_HISTORY VARCHAR(2048) WITH DEFAULT 'CREATED',
		  PUBLIC_FLAG CHAR(1) NOT NULL WITH DEFAULT '0',
		  COMPANY_BACKGROUND VARCHAR(3000) ,
		  OWNERSHIP VARCHAR(2048) ,
		  SERVICES_OFFERED VARCHAR(2048) ,
		  SERVICES_SPECIALIZED VARCHAR(2048) ,
		  INDUSTRIES_SERVED VARCHAR(2048) ,
		  HIGHLIGHT VARCHAR(2048) ,
		  LOCATION_SERVED VARCHAR(2048),
		  SCORECARD_COUNT INTEGER WITH DEFAULT 0,
		  DOC_COUNT INTEGER  WITH DEFAULT 0,
		  CREATED_BY CHAR(32),
		  ASSIGN_NAMES VARCHAR(2048),
		  CLEARANCE_LEVEL_1 INTEGER NOT NULL WITH DEFAULT 1275905024,
		  CLEARANCE_LEVEL_2 INTEGER NOT NULL WITH DEFAULT 1280101580,
		  CLEARANCE_LEVEL_3 INTEGER NOT NULL WITH DEFAULT 4,
		  CLEARANCE_LEVEL_4 INTEGER NOT NULL WITH DEFAULT 0,
		  CLEARANCE_LEVEL_5 INTEGER NOT NULL WITH DEFAULT 0,
		  USER_GROUP_ID CHAR(32) NOT NULL WITH DEFAULT 'DEFAULT_SECURITY_ROLE',
		  MASK_EMPLOYEE_INFO SMALLINT WITH DEFAULT 1,
		  COST_CENTER_ID CHAR(32),
		  EXTERNAL_REFERENCE CHAR(32))
		 IN ALL32K INDEX IN TS_INDEX ;
 ALTER TABLE TMT_POOLS PCTFREE 30;

INSERT INTO TMT_POOLS_TMP
(	
	LEVEL_ID ,
	TYPE_ID ,
	MAX_RANK ,
	CHILD_COUNT,
	DELETED_COUNT,
	ELEMENT_ID  ,
	ELEMENT_NAME ,
	PARENT_ID ,
	REC_USER ,
	REC_STATUS,
	REC_DATETIME ,
	LABEL,
	DESCRIPTION ,
	DEFAULT_FLAG  ,
	RANK ,
	DOMAIN_ID ,
	MANAGER_ID ,
	COMPANY_NAME ,
	ADDRESS  ,
	PHONE  ,
	FAX  ,
	WEBSITE,
	CONTACT_NAME ,
	OTHER_LOCATION  ,
	YEAR_IN_BUSINESS ,
	CLIENT_MORE_100_EMPLOYEES,
	CLIENT_MORE_1000_EMPLOYEES  ,
	CLIENT_MORE_10000_EMPLOYEES  ,
	NUMBER_EMPLOYEES  ,
	NUMBER_POOLS ,
	NUMBER_CLIENTS ,
	ANNUAL_REVENUES ,
	BILLING_ADDRESS,
	BILLING_PHONE ,
	BILLING_FAX,
	BILLING_EMAIL ,
	EQUAL_OPPORTUNITY ,
	MAJOR_REVISION ,
	MINOR_REVISION ,
	REVISION_IMPACT ,
	REVISION_TYPE ,
	REVISION_HISTORY,
	PUBLIC_FLAG ,
	COMPANY_BACKGROUND,
	OWNERSHIP,
	SERVICES_OFFERED,
	SERVICES_SPECIALIZED,
	INDUSTRIES_SERVED,
	HIGHLIGHT,
	LOCATION_SERVED,
	SCORECARD_COUNT,
	DOC_COUNT,
	CREATED_BY,
	ASSIGN_NAMES ,
	CLEARANCE_LEVEL_1 ,
	CLEARANCE_LEVEL_2 ,
	CLEARANCE_LEVEL_3 ,
	CLEARANCE_LEVEL_4 ,
	CLEARANCE_LEVEL_5 ,
	USER_GROUP_ID ,
	MASK_EMPLOYEE_INFO,
	COST_CENTER_ID,
	EXTERNAL_REFERENCE
)
SELECT LEVEL_ID ,
	TYPE_ID ,
	MAX_RANK ,
	CHILD_COUNT,
	DELETED_COUNT,
	ELEMENT_ID  ,
	ELEMENT_NAME ,
	PARENT_ID ,
	REC_USER ,
	REC_STATUS,
	REC_DATETIME ,
	LABEL,
	DESCRIPTION ,
	DEFAULT_FLAG  ,
	RANK ,
	DOMAIN_ID ,
	MANAGER_ID ,
	COMPANY_NAME ,
	ADDRESS  ,
	PHONE  ,
	FAX  ,
	WEBSITE,
	CONTACT_NAME ,
	OTHER_LOCATION  ,
	YEAR_IN_BUSINESS ,
	CLIENT_MORE_100_EMPLOYEES,
	CLIENT_MORE_1000_EMPLOYEES  ,
	CLIENT_MORE_10000_EMPLOYEES  ,
	NUMBER_EMPLOYEES  ,
	NUMBER_POOLS ,
	NUMBER_CLIENTS ,
	ANNUAL_REVENUES ,
	BILLING_ADDRESS,
	BILLING_PHONE ,
	BILLING_FAX,
	BILLING_EMAIL ,
	EQUAL_OPPORTUNITY ,
	MAJOR_REVISION ,
	MINOR_REVISION ,
	REVISION_IMPACT ,
	REVISION_TYPE ,
	REVISION_HISTORY,
	PUBLIC_FLAG ,
	COMPANY_BACKGROUND,
	OWNERSHIP,
	SERVICES_OFFERED,
	SERVICES_SPECIALIZED,
	INDUSTRIES_SERVED,
	HIGHLIGHT,
	LOCATION_SERVED,
	SCORECARD_COUNT,
	DOC_COUNT,
	CREATED_BY,
	ASSIGN_NAMES ,
	CLEARANCE_LEVEL_1 ,
	CLEARANCE_LEVEL_2 ,
	CLEARANCE_LEVEL_3 ,
	CLEARANCE_LEVEL_4 ,
	CLEARANCE_LEVEL_5 ,
	USER_GROUP_ID ,
	MASK_EMPLOYEE_INFO,
	COST_CENTER_ID,
	EXTERNAL_REFERENCE
FROM TMT_POOLS;


--renaming the TMT_POOLS to OLD_TMT_POOLS, and TMT_POOLS_TMP to TMT_POOLS

RENAME TABLE TMT_POOLS TO OLD_TMT_POOLS;
RENAME TABLE TMT_POOLS_TMP TO TMT_POOLS;


--creating the indexes for new TMT_POOLS

CREATE UNIQUE INDEX TPOOL_ENID_XU ON TMT_POOLS
		(ELEMENT_ID ASC,
		 PARENT_ID ASC)
		INCLUDE (ELEMENT_NAME ASC) ;



CREATE UNIQUE INDEX TPOOL_RK_CU ON TMT_POOLS
(RANK ASC) 
INCLUDE(TYPE_ID,LEVEL_ID) 
CLUSTER MINPCTUSED 10 
PCTFREE 30;                      

CREATE INDEX POOL_DOM_ID_XXX ON TMT_POOLS (DOMAIN_ID) MINPCTUSED 10 PCTFREE 30; 
CREATE INDEX POOL_USRGROUP_XXX ON TMT_POOLS (USER_GROUP_ID) MINPCTUSED 10 PCTFREE 30; 
CREATE INDEX POOL_MGR_XXX ON TMT_POOLS (MANAGER_ID) MINPCTUSED 10 PCTFREE 30; 
CREATE INDEX TPOO_NID_XX ON TMT_POOLS(PARENT_ID) MINPCTUSED 10 PCTFREE 30; 
CREATE INDEX TPOOL_EXTREF_XX ON TMT_POOLS (EXTERNAL_REFERENCE ASC);

-- IF THE ABOVE SQL STATEMENTS ARE SUCCESSFUL THEN DROP the old tmt_pools table that is renamed to OLD_TMT_POOLS;

--DROP TABLE OLD_TMT_POOLS;

--HISTORY_POOLS


DROP INDEX HSPLX_EID_RDT_CX;
DROP INDEX HSPLX_HID_XX;
DROP  INDEX HSPLX_RK_XX;                                                     
DROP INDEX TPOOL_EXTREF_XX;	


CREATE TABLE HISTORY_POOLS_TMP  (
		  HISTORY_ID CHAR(32) ,
		  LEVEL_ID INTEGER NOT NULL ,
		  TYPE_ID INTEGER NOT NULL WITH DEFAULT 0,
		  MAX_RANK INTEGER NOT NULL WITH DEFAULT 0,
		  CHILD_COUNT INTEGER NOT NULL WITH DEFAULT 0,
		  DELETED_COUNT INTEGER NOT NULL WITH DEFAULT 0,
		  ELEMENT_ID CHAR(32) ,
		  ELEMENT_NAME VARCHAR(100) ,
		  PARENT_ID CHAR(32) ,
		  REC_USER CHAR(32) ,
		  REC_STATUS CHAR(1) NOT NULL WITH DEFAULT 'O',
		  REC_DATETIME TIMESTAMP NOT NULL WITH DEFAULT CURRENT TIMESTAMP,
		  LABEL VARCHAR(50) ,
		  DESCRIPTION VARCHAR(4096) ,
		  DEFAULT_FLAG CHAR(1) ,
		  RANK VARCHAR(128) NOT NULL ,
		  DOMAIN_ID CHAR(32) ,
		  MANAGER_ID CHAR(32) ,
		  COMPANY_NAME VARCHAR(50) ,
		  ADDRESS VARCHAR(255) ,
		  PHONE VARCHAR(25) ,
		  FAX VARCHAR(25) ,
		  WEBSITE VARCHAR(255) ,
		  CONTACT_NAME VARCHAR(50) ,
		  OTHER_LOCATION VARCHAR(255) ,
		  YEAR_IN_BUSINESS INTEGER ,
		  CLIENT_MORE_100_EMPLOYEES INTEGER ,
		  CLIENT_MORE_1000_EMPLOYEES INTEGER ,
		  CLIENT_MORE_10000_EMPLOYEES INTEGER ,
		  NUMBER_EMPLOYEES INTEGER ,
		  NUMBER_POOLS INTEGER ,
		  NUMBER_CLIENTS INTEGER ,
		  ANNUAL_REVENUES DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		  BILLING_ADDRESS VARCHAR(255) ,
		  BILLING_PHONE VARCHAR(25) ,
		  BILLING_FAX VARCHAR(25) ,
		  BILLING_EMAIL VARCHAR(50) ,
		  EQUAL_OPPORTUNITY CHAR(1) ,
		  MAJOR_REVISION SMALLINT NOT NULL WITH DEFAULT 0,
		  MINOR_REVISION SMALLINT NOT NULL WITH DEFAULT 1,
		  REVISION_IMPACT INTEGER WITH DEFAULT 137,
		  REVISION_TYPE INTEGER WITH DEFAULT 920,
		  REVISION_HISTORY VARCHAR(2048),
		  PUBLIC_FLAG CHAR(1) NOT NULL WITH DEFAULT '0',
		  COMPANY_BACKGROUND VARCHAR(3000) ,
		  OWNERSHIP VARCHAR(2048) ,
		  SERVICES_OFFERED VARCHAR(2048) ,
		  SERVICES_SPECIALIZED VARCHAR(2048) ,
		  INDUSTRIES_SERVED VARCHAR(2048) ,
		  HIGHLIGHT VARCHAR(2048) ,
		  LOCATION_SERVED VARCHAR(2048),
		  SCORECARD_COUNT INTEGER WITH DEFAULT 0,
		  DOC_COUNT INTEGER  WITH DEFAULT 0,
		  CREATED_BY CHAR(32),
		  ASSIGN_NAMES VARCHAR(2048),
		  CLEARANCE_LEVEL_1 INTEGER NOT NULL WITH DEFAULT 1275905024,
		  CLEARANCE_LEVEL_2 INTEGER NOT NULL WITH DEFAULT 1280101580,
		  CLEARANCE_LEVEL_3 INTEGER NOT NULL WITH DEFAULT 4,
		  CLEARANCE_LEVEL_4 INTEGER NOT NULL WITH DEFAULT 0,
		  CLEARANCE_LEVEL_5 INTEGER NOT NULL WITH DEFAULT 0,
		  USER_GROUP_ID CHAR(32) NOT NULL WITH DEFAULT 'DEFAULT_SECURITY_ROLE',
		  MASK_EMPLOYEE_INFO SMALLINT WITH DEFAULT 1,
		  COST_CENTER_ID CHAR(32),
		  EXTERNAL_REFERENCE CHAR(32))
		 IN ALL32K INDEX IN TS_INDEX ;
 ALTER TABLE HISTORY_POOLS PCTFREE 30;
 
 
 INSERT INTO HISTORY_POOLS_TMP
 (
			HISTORY_ID ,
		  LEVEL_ID,
		  TYPE_ID,
		  MAX_RANK,
		  CHILD_COUNT,
		  DELETED_COUNT,
		  ELEMENT_ID,
		  ELEMENT_NAME,
		  PARENT_ID,
		  REC_USER,
		  REC_STATUS,
		  REC_DATETIME ,
		  LABEL ,
		  DESCRIPTION,
		  DEFAULT_FLAG,
		  RANK ,
		  DOMAIN_ID ,
		  MANAGER_ID,
		  COMPANY_NAME,
		  ADDRESS,
		  PHONE ,
		  FAX ,
		  WEBSITE,
		  CONTACT_NAME,
		  OTHER_LOCATION ,
		  YEAR_IN_BUSINESS ,
		  CLIENT_MORE_100_EMPLOYEES ,
		  CLIENT_MORE_1000_EMPLOYEES  ,
		  CLIENT_MORE_10000_EMPLOYEES ,
		  NUMBER_EMPLOYEES ,
		  NUMBER_POOLS ,
		  NUMBER_CLIENTS  ,
		  ANNUAL_REVENUES ,
		  BILLING_ADDRESS  ,
		  BILLING_PHONE,
		  BILLING_FAX ,
		  BILLING_EMAIL ,
		  EQUAL_OPPORTUNITY,
		  MAJOR_REVISION ,
		  MINOR_REVISION ,
		  REVISION_IMPACT ,
		  REVISION_TYPE ,
		  REVISION_HISTORY,
		  PUBLIC_FLAG ,
		  COMPANY_BACKGROUND ,
		  OWNERSHIP,
		  SERVICES_OFFERED ,
		  SERVICES_SPECIALIZED  ,
		  INDUSTRIES_SERVED ,
		  HIGHLIGHT ,
		  LOCATION_SERVED,
		  SCORECARD_COUNT,
		  DOC_COUNT,
		  CREATED_BY ,
		  ASSIGN_NAMES,
		  CLEARANCE_LEVEL_1 ,
		  CLEARANCE_LEVEL_2 ,
		  CLEARANCE_LEVEL_3 ,
		  CLEARANCE_LEVEL_4 ,
		  CLEARANCE_LEVEL_5 ,
		  USER_GROUP_ID,
		  MASK_EMPLOYEE_INFO,
		  COST_CENTER_ID,
		  EXTERNAL_REFERENCE
)
SELECT HISTORY_ID ,
		  LEVEL_ID,
		  TYPE_ID,
		  MAX_RANK,
		  CHILD_COUNT,
		  DELETED_COUNT,
		  ELEMENT_ID,
		  ELEMENT_NAME,
		  PARENT_ID,
		  REC_USER,
		  REC_STATUS,
		  REC_DATETIME ,
		  LABEL ,
		  DESCRIPTION,
		  DEFAULT_FLAG,
		  RANK ,
		  DOMAIN_ID ,
		  MANAGER_ID,
		  COMPANY_NAME,
		  ADDRESS,
		  PHONE ,
		  FAX ,
		  WEBSITE,
		  CONTACT_NAME,
		  OTHER_LOCATION ,
		  YEAR_IN_BUSINESS ,
		  CLIENT_MORE_100_EMPLOYEES ,
		  CLIENT_MORE_1000_EMPLOYEES  ,
		  CLIENT_MORE_10000_EMPLOYEES ,
		  NUMBER_EMPLOYEES ,
		  NUMBER_POOLS ,
		  NUMBER_CLIENTS  ,
		  ANNUAL_REVENUES ,
		  BILLING_ADDRESS  ,
		  BILLING_PHONE,
		  BILLING_FAX ,
		  BILLING_EMAIL ,
		  EQUAL_OPPORTUNITY,
		  MAJOR_REVISION ,
		  MINOR_REVISION ,
		  REVISION_IMPACT ,
		  REVISION_TYPE ,
		  REVISION_HISTORY,
		  PUBLIC_FLAG ,
		  COMPANY_BACKGROUND ,
		  OWNERSHIP,
		  SERVICES_OFFERED ,
		  SERVICES_SPECIALIZED  ,
		  INDUSTRIES_SERVED ,
		  HIGHLIGHT ,
		  LOCATION_SERVED,
		  SCORECARD_COUNT,
		  DOC_COUNT,
		  CREATED_BY ,
		  ASSIGN_NAMES,
		  CLEARANCE_LEVEL_1 ,
		  CLEARANCE_LEVEL_2 ,
		  CLEARANCE_LEVEL_3 ,
		  CLEARANCE_LEVEL_4 ,
		  CLEARANCE_LEVEL_5 ,
		  USER_GROUP_ID,
		  MASK_EMPLOYEE_INFO,
		  COST_CENTER_ID,
		  EXTERNAL_REFERENCE
FROM HISTORY_POOLS;

--renaming the original table HISTORY_POOLS to OLD_HISTORY_POOLS, and HISTPRY_POOLS_TMP to HISTORY_POOLS

RENAME TABLE HISTORY_POOLS TO OLD_HISTORY_POOLS;
RENAME TABLE HISTORY_POOLS_TMP TO HISTORY_POOLS;


--creating the indexes for new HISTORY_POOLS

CREATE INDEX HSPLX_EID_RDT_CX ON HISTORY_POOLS
		(ELEMENT_ID ASC,
		 REC_DATETIME ASC)
		CLUSTER
		 MINPCTUSED 10
		 PCTFREE 30;
		 
CREATE INDEX HSPLX_HID_XX ON HISTORY_POOLS
		(HISTORY_ID ASC);

CREATE  INDEX HSPLX_RK_XX ON HISTORY_POOLS
	(RANK ASC)  MINPCTUSED 10 
	PCTFREE 30;       
	
ALTER TABLE TMT_POOLS ALTER COLUMN REVISION_HISTORY SET DATA TYPE VARCHAR(4100); 
ALTER TABLE HISTORY_POOLS ALTER COLUMN REVISION_HISTORY SET DATA TYPE VARCHAR(4100);   	        
	
CONNECT RESET;	                                      
		